#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "gg.h"

int main(int argc, char **argv)
{
	unsigned char value, cvalue;
	unsigned short address;
	char *codestr;
	int i;
	
	if (argc<2) {
		printf("Usage: ./nesgg code 1 ... [code N] \n");
		printf("\n");
		printf("Decodes all game genie codes (8 or 6 lettters)\n");
		printf("passed on the command line.\n\n");
		return 1;
	}


	for (i=1; i<argc; i++)
	{
		codestr = argv[i];
		
		switch (strlen(codestr))
		{
			case 6:	
				if (gg_decode6letters(codestr, &address, &value)<0) {
					fprintf(stderr, "Invalid code\n");
					return 1;
				}	
				printf("%8s: Value: $%02X   Address: $%04X\n", codestr, value, address);
			case 8:
				if (gg_decode8letters(codestr, &address, &value, &cvalue)<0) {
					fprintf(stderr, "Invalid code\n");
					return 1;
				}
				printf("%8s: Value: $%02X  Compare Value: $%02X  Address: $%04X\n", codestr, value, cvalue, address);
				break;
			default:
				fprintf(stderr, "Code must be 8 or 6 letters.\n");
				return 1;
		}

	}
	
	
	return 0;
}


